"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const TipContainer = ({ children, style, scrollLeft, scrollTop, pageBoundingRect, containerOffset }) => {
    const [height, setHeight] = (0, react_1.useState)(0);
    const [width, setWidth] = (0, react_1.useState)(0);
    const containerRef = react_1.default.useRef(null);
    const updatePosition = () => {
        const container = containerRef.current;
        if (!container) {
            return;
        }
        const { offsetHeight, offsetWidth } = container;
        setHeight(offsetHeight);
        setWidth(offsetWidth);
    };
    (0, react_1.useEffect)(() => {
        updatePosition();
    }, [children]);
    (0, react_1.useEffect)(() => {
        setTimeout(updatePosition, 0);
    }, []);
    const isStyleCalculationInProgress = width === 0 && height === 0;
    const shouldMove = style.top - height - 5 < scrollTop;
    const top = shouldMove ? style.bottom + 5 : style.top - height - 5;
    const left = Math.min(Math.max(style.left - width / 2, 0), scrollLeft + ((containerOffset === null || containerOffset === void 0 ? void 0 : containerOffset.offsetWidth) || 0) - width - 20);
    const childrenWithProps = react_1.default.Children.map(children, child => 
    // @ts-ignore
    react_1.default.cloneElement(child, {
        onUpdate: () => {
            setWidth(0);
            setHeight(0);
            setTimeout(updatePosition, 0);
        },
        popup: {
            position: shouldMove ? "below" : "above"
        }
    }));
    return (react_1.default.createElement("div", { className: "PdfHighlighter__tip-container", style: {
            visibility: isStyleCalculationInProgress ? "hidden" : "visible",
            top,
            left
        }, ref: containerRef }, childrenWithProps));
};
exports.default = TipContainer;
//# sourceMappingURL=TipContainer.js.map